<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?PHP
 include_once("security.php") ; 
 include_once("diag.php") ;
 add_diag("Toppy_Web starting") ;
 //echo "config_php.ini" ;
 include_once ("config_lib.php") ;
 
 ini_set("short_open_tag","On") ;
 
 if (version_compare(PHP_VERSION,"5.0.0")<0) { include "compat_5.0.0.php" ; }

 $default_ini = array() ;
 $def_name="default.ini" ;
 $ini_name="config.ini"  ;
 if (array_key_exists("inifile",$_GET)) { $ini_name = $_GET["inifile"] ; }
 
 if (file_exists($def_name)) { $default_ini = parse_ini_file($def_name, true) ; add_diag("[CONFIG] read $def_name") ;}
 if (file_exists($ini_name)) { $config_ini  = parse_ini_file($ini_name, true) ; add_diag("[CONFIG] read $ini_name") ; }
 else                        { $config_ini  = $default_ini ; add_diag("[CONFIG] no $ini_name") ; }
  
 $config_folder = get_ini_string("General","ConfigFolder","") ;
 if ($config_folder<>"")
 {
  $ini_name = $config_folder.DIRECTORY_SEPARATOR.$ini_name ;
  if (file_exists($ini_name)) { $config_ini  = parse_ini_file($ini_name, true) ; add_diag("[CONFIG] read $ini_name") ; }
  else                        { $config_ini  = $default_ini ; add_diag("[CONFIG] no $ini_name") ; }
 }
 
 
 //echo count($default_ini)." | ".count($config_ini) ;
 //print_r($config_ini) ;
 
 $show_diag = get_ini_boolean("General","DiagnosticMode",false) ;  // turn diagnostic display on or off
 if (array_key_exists("showdiag",$_GET)) { $show_diag = set_boolean($_GET["showdiag"],$show_diag) ; }
 //echo "ShowDiag = ".yes_if_true($show_diag)."<br>\n" ; 
 
     // Should we go to Demonstration Modes
		 $demo_mode          = get_ini_boolean("Demo Mode","EnableDemoMode",false) ;  // 
		 $force_cache        = get_ini_boolean("Demo Mode","ForceCache",false) ;  // 
		 $force_current_date = get_ini_string("Demo Mode","ForceCurrentDate","") ;  // 
 
 
		// TEDS or PBK in use?
		$use_LCN   = get_ini_boolean("General","UseLCN",false) ;
		$use_teds   = get_ini_boolean("General","TEDS",true) ;
		$use_pbk    = get_ini_boolean("General","PBK",false) ;
		$use_trecx  = get_ini_boolean("General","TrecX",false) ;
		$show_epg   = get_ini_boolean("General","ShowEPG",true) ;
		$show_logs  = get_ini_boolean("General","ShowLogs",true) ;
		$use_ajax  = get_ini_boolean("General","UseAjax",false) ;
		$teds_type  = get_ini_string("TEDS","Type","TEDS") ;
		
		$FTPservers = get_ini_array("General","FTPservers","MyToppy") ;
		foreach ($FTPservers as $value) { set_ini_section_default("FTP $value","FTP") ; }
		
		$MyToppies  = get_ini_array("General","MyToppies",$FTPservers[0]) ;
		foreach ($MyToppies as $value) { set_ini_section_default("Topfield $value","Topfield") ; }
		foreach ($MyToppies as $value) { set_ini_section_default("Timers $value","Timers") ; }
		
		$RECservers  = get_ini_array("General","RECservers") ;
		//echo "RECservers = ".count($RECservers)." ";print_r($RECservers) ;
		$is_RECserver = false ;
		foreach ($RECservers as $index => $value) 
		{
		 //echo "RECserver[$index]=".is_string($value).($value=="")."$value\n" ;
		 if ("$value"<>"") { set_ini_section_default("RECserver $value","RECserver") ; $is_RECserver = true ; }
		 else              { unset($RECservers[$value]) ; } 
		}
		if (!$is_RECserver) { $RECservers = array() ;}
		//echo "RECservers = ".count($RECservers)." ";print_r($RECservers) ;
		//foreach ($RECservers as $value) { set_ini_section_default("RECserver $value","RECserver") ; }
		
		$Grabbers   = get_ini_array("General","Grabbers") ;
		foreach ($Grabbers as $value) { set_ini_section_default("Grabber $value","Grabber") ; }
		foreach ($Grabbers as $value) { $use_grabber[$value]=true ; }
		foreach ($Grabbers as $value) { add_diag("[CONFIG] Grabber=$value") ; }
				
		$ExtraLogs   = get_ini_array("General","ExtraLogs") ;
		
		$force_win_names = get_ini_boolean("Recordings","ForceWinNames",false) ;
 
    // Operating system where Toppy-Web is running
		 $platform          = get_ini_string("Web Server","Platform","Windows") ;
		 $rename_attempts   = get_ini_string("Web Server","MaxRenameAttempts",9) ;
		 $cache_enabled     = get_ini_boolean("Web Server","EnableCaching",false) ;
		 //$cache_extended  = get_ini_boolean("Web Server","EnableExtendedCaching",false) ;
		 $extended_desc     = get_ini_boolean("Web Server","ExtendedDescriptions",false) ;
		 $extended_desc_log = get_ini_boolean("Web Server","ExtendedDescriptionsLog",false) ;
		 $date_timezone=get_ini_string("Web Server","DateTimezone","") ;
		 //echo "d.tz=$date_timezone\n" ;
		 if ( $date_timezone<>"") 
		 {
		  //echo "<!-- DatTimezon => $date_timezone -->\n" ;
      //echo "<!-- Original Time: ". date("d M H:i:s O")." -->\n";
		  ini_set("date.timezone",$date_timezone) ; 
      //echo "<!-- Original Time: ". date("d M H:i:s O")." -->\n";
      putenv("TZ=$date_timezone");
      //echo "<!-- New Time: ". date("d M H:i:s O")." -->\n";
		 }
		 
		 // Local files is a working folder where Toppy-web can stored files FTP'd from the Toppy
		 // Toppy-web needs read-write access to this folder
		 // the below values are suggested locations for each platform
		 $local_files = get_ini_string("Platform $platform","WorkingFolder","/opt/var/toppy-web") ;
		 $separator["Local"] = DIRECTORY_SEPARATOR ;
		 $TFepgdata["Local"] = "" ;
		 $TFicetv["Local"]   = "" ;
		 
		 $security = get_ini_string("Security","Method","Server") ;
		 $userlist[0] = "NoList" ;  // prepare for failure
		 if (strtolower($security) == "server") 
		 { 
			 // Do nothing - let the server do it all
			 $sec_message = "Server will provide security" ;
		 }
		 else if (strtolower($security) == "php") 
		 {
		  $sec_message = "User List defined in userlist.php" ;
		  if (file_exists("userlist.php")) { include_once("userlist.php") ; $userlist = explode(",",$str_userlist) ; }
			else { $security = "Server" ; $sec_message = "No userlist.php found" ; }
		 }
		 else if (strtolower($security) == "file") 
		 {
		  $sec_message = "User List defined in ".($userfile=$local_files.DIRECTORY_SEPARATOR."userlist.txt") ;
		  if (file_exists($userfile)) { $userlist = file($userfile) ; }
			else { $security = "Server" ; $sec_message = "No userlist.txt found" ; }
		 }
		 else if (strtolower($security) == "config")
		 {		  
		  $sec_message = "User List defined in config.ini" ;
			$userlist = get_ini_array("Security","UserList","NoList") ;
		 }
		 else
		 {
		  $sec_message = "Invalid security option: $security" ;
		  $security = "Server" ;
			$userlist[0] = "NoList" ;		  
		 }		 
		 
		 add_diag("Config: User Count ".count($userlist)) ;
		 
		 if (count($userlist)<1) { $userlist[0] = "NoList" ; }  // Empty list?
		 foreach ($userlist as $index => $value)
		 {
		  list($tw_user[$index],$tw_password[$index]) = explode("/",trim($userlist[$index]),2) ;
			// build the string of users
			if ($index==0) { $str_userlist = $tw_user[$index] ; }
			else           { $str_userlist .= ",".$tw_user[$index] ; }  
  	 }
		 
		 add_diag("Config: Userlist $str_userlist") ;
		
		 if ($tw_user[0]=="NoList") 
		 {
			if (strtolower($security)<>"server") {$sec_message = "Userlist was empty in $security" ; }
		  $security = "Server" ; 
		 }
		
		$Channels    = get_ini_array("General","Channels","ABC,ABC2,Seven,Nine,TEN,SBS,SBS News") ;
		//foreach ($Channels as $value)
		$index = 0 ;
		while ($value = $Channels[$index++])
		{
		 $chn_names[get_ini_string("Channel $value","ToppyName",$value)] = $value ;
		 $ice_chn_trans[get_ini_string("Channel $value","IceTVname",$value)] = $value ;
		 $xml_chn_trans[get_ini_string("Channel $value","XMLname",$value)] = $value ;
		 $lcn_chn_trans[get_ini_string("Channel $value","LCN",$value)] = $value ;
		 $chn_hide[$value] = get_ini_boolean("Channel $value","HideEPG",false) ;
		 
		 $chn_alternate[$value] = ($alternate=get_ini_string("Channel $value","Alternate","")) ;
		 if( !in_array($alternate,$Channels) and $alternate<>"" ) { $Channels[] = $alternate ; }
		 
		 $chn_hdtv[$value] = ($hdtv=get_ini_string("Channel $value","HDTV","")) ;
		 if( !in_array($hdtv,$Channels) and $hdtv<>"" ) { $Channels[] = $hdtv ; }
		}   
		//echo "<!-- ";print_r($Channels);echo " -->\n" ;
		//echo "<!-- ";print_r($chn_alternate);echo " -->\n" ;
		//echo "<!-- ";print_r($chn_hdtv);echo " -->\n" ;
		 		
		 // FTP server details (these are the details of the FTP servers that connect to a Toppy)		 
		 foreach ($FTPservers as $value)
		 {
		  $FTPtype[$value]    = get_ini_string("FTP $value","Type","other") ;
		  $FTPaddress[$value] = get_ini_string("FTP $value","Name","localhost") ;
		  $FTPaddress[$value] = get_ini_string("FTP $value","Address",$FTPaddress[$value]) ;
		  $FTPport[$value]    = get_ini_string("FTP $value","Port",21) ;
		  $FTPuser[$value]    = get_ini_string("FTP $value","Username","toppyweb") ;
		  $FTPpw[$value]      = get_ini_string("FTP $value","Password","password") ;
		  $separator[$value]  = get_ini_string("FTP $value","DirectorySeparator","/") ;
		 }
		 foreach ($FTPtype as $key => $value)
		 {
		  $FTPoffset[$key]    = get_ini_string("FTP $value","FilenameOffset",51) ;
		  $FTPsleepwake[$key] = get_ini_boolean("FTP $value","SleepWake",false) ;
		  $FTPsleepcmd[$key]  = get_ini_string("FTP $value","SleepCommand","sleep") ;
		  $FTPwakecmd[$key]   = get_ini_string("FTP $value","WakeCommand","wakeup") ;
		 }
		 $firstFTP        = $FTPservers[0] ;  // for backward compatability
		 $server_type     = $FTPtype[$firstFTP] ;     
		 $ftp_server      = $FTPaddress[$firstFTP] ;
		 $ftp_port        = $FTPport[$firstFTP] ;
		 $user_name       = $FTPuser[$firstFTP] ;
		 $user_pw         = $FTPpw[$firstFTP] ;
		 $filename_offset = $FTPoffset[$firstFTP] ; 
		 
		 
		 // Toppy details
		 foreach ($MyToppies as $value)
		 {
		  $TFdatafiles[$value]    = get_ini_string("Topfield $value","DataFiles","/DataFiles") ;
		  $TFepgdata[$value]      = get_ini_string("Topfield $value","EPGdata","/EPGdata") ;
		  $TFprogramfiles[$value] = get_ini_string("Topfield $value","ProgramFiles","/ProgramFiles") ;
		  $TFautostart[$value]    = get_ini_string("Topfield $value","AutoStart","/ProgramFiles/Auto Start") ;
		  $TFicetv[$value]        = get_ini_string("Topfield $value","IceTV","/ICE") ;
		  $TFuseLCN[$value]       = get_ini_boolean("Topfield $value","UseLCN",$use_LCN) ;
		  $TFhdd[$value]          = get_ini_string("Topfield $value","HDDsize",120)*1000*1000*1000 ;
		  $TFexpandServer[$value] = get_ini_boolean("Topfield $value","ExpandServer",true) ;
		  $TFexpandFolders[$value]= get_ini_boolean("Topfield $value","ExpandFolders",true) ;
			$TFtimers_server[$value]= get_ini_string("Timers $value","Servername",$value) ;
			$TFtimers_folder[$value]= get_ini_string("Timers $value","Folder",$TFepgdata[$TFtimers_server[$value]]) ;
		 }
		 $firstToppy      = $MyToppies[0] ;  // for backward compatibility
		 $epg_data        = $TFepgdata[$firstToppy] ;
		 $data_files      = $TFdatafiles[$firstToppy] ;
		 $program_files   = $TFprogramfiles[$firstToppy] ;
		 $auto_start      = $TFautostart[$firstToppy] ;
		 $icetv_files     = $TFicetv[$firstToppy] ;
		 $hdd_size        = $TFhdd[$firstToppy] ;
		 // in case Local is specified as the server for any files
		 $TFepgdata["Local"]      = $local_files ;
		 $TFprogramfiles["Local"] = $local_files ;
		 $TFdatafiles["Local"]    = $local_files ;
		 
		 $teds_server     = get_ini_string("TEDS","Server","Local") ;
		 $teds_location   = get_ini_string("TEDS",$teds_type,"C:\\Program Files\\TEDS") ;
		 $teds_location   = get_ini_string("TEDS","Folder","$teds_location") ; // Folder will over-ride any preset location
		 $teds_log        = get_ini_string("TEDS","TedsLog","TED.log") ;
		 $teds_timers     = get_ini_string("TEDS","TedsTimers","timers.log") ;
		 if ($teds_server=="Local") { $teds_servertype = "local" ; }
		 else                       { $teds_servertype = "ftp" ; }
		 //set_ini_section_default("TEDS $teds_type","TEDS") ;
		 
		 
		 // RECserver details
		 foreach ($RECservers as $value)
		 {
		  // treat a RECserver as a psuedo Toppy
		  $TFdatafiles[$value]    = $RECfolder[$value] = get_ini_string("RECserver $value","Folder","/DataFiles") ;
		  $TFhdd[$value]          = $REChdd[$value]    = get_ini_string("RECserver $value","HDDsize",120)*1000*1000*1000 ;
		  $TFexpandServer[$value] = get_ini_boolean("RECserver $value","ExpandServer",true) ;
		  $TFexpandFolders[$value]= get_ini_boolean("RECserver $value","ExpandFolders",true) ;
		 }
		 
		 
		 $timers_server = get_ini_string("Timers","Servername",$MyToppies[0]) ;
		 if ($timers_server=="auto") { $timers_server = $MyToppies[0] ; }
		 //add_diag( "timers server=$timers_server" ) ;
		 
		 $timers_folder = get_ini_string("Timers","Folder",$TFepgdata[$timers_server]) ;
		 if ($timers_folder=="auto") { $timers_folder = $TFepgdata[$timers_server] ; }
		 //add_diag( "timers folder=$timers_folder" ) ;
		 
		 // rec/play file location
		 $epg_recplay      = get_ini_string("Timers","RecPlay","epg_recplay") ;
		 $epg_recplay_rem  = $timers_folder ;
		 $epg_recplay_loc  = $local_files ;
		 
		 // Current timer location
		 $epg_timers      = get_ini_string("Timers","CurrentTimers","epg_timers.tsv") ;
		 $epg_timers_rem  = $timers_folder ;
		 $epg_timers_loc  = $local_files ;
		 //add_diag( "epg timers remote=$epg_timers_rem" ) ;
		 
		 // Pending timer locations (may reference standard locations)
		 $set_timers_tgd  = get_ini_string("Timers","PendingTimers","99999999.tgd") ;
		 $set_timers_rem  = $timers_folder ;
		 $set_timers_loc  = $local_files ;
		 
		 // EPG uploader log (may reference standard locations)
		 $epg_loader_log  = get_ini_string("Timers","Log","epg_upload.log") ;
		 $epg_loader_rem  = $timers_folder ;
		 $epg_loader_loc  = $local_files ;
		 
		 // These are the default values used when creating new timers
		 $default_duration = get_ini_string("Timers","DefaultDuration",120) ;
		 $default_prepad   = get_ini_string("Timers","DefaultPrepad","-05") ;
		 $default_postpad  = get_ini_string("Timers","DefaultPostpad","+10") ;
		 $default_padding = "$default_prepad $default_postpad"; // Do not alter this value
		 // number of days/dates to show in list when creating a new timer
		 $number_days = get_ini_string("Timers","NumberOfDays",30) ;
		 
		 // Recordings location (may reference standard locations)
		 $recordings_dir     = get_ini_string("Recordings","Folder",$data_files) ;
		 $files_initial_sort = get_ini_string("Recordings","InitialSort","Name") ;
		 		 		 
		 // Do you want to allow management of VCR timers?
		 $vcr_timers = get_ini_boolean("Timers","VCRtimers",true) ;  // set to true or false
		 		 		 
		 // Do you want to show VCR timers (eg PBK time set) on the EPG display?
		 $show_vcr_timers_on_epg = get_ini_boolean("EPG","ShowVCRtimers",true) ;  // set to true or false
		 		 		 
		 // details of files for list of log files to display
		 //
		 // list_file_entry   is the name that appears in the selection list
		 // list_file_name    is the actual name of the file (may refer to a previously defined value)
		 // list_file_type    is how Toppy-Web finds the the file ("ftp" or "local")
		 // list_file_loc     is the location of the file (may refer to a standard location)
		 
		foreach ($MyToppies as $value)
		{
		 $list_file_entry["$value epg_recplay"]  = "$value Active Rec/Play list";
		 $list_file_name["$value epg_recplay"]   = $epg_recplay;
		 $list_file_server["$value epg_recplay"] = $value ;
		 $list_file_type["$value epg_recplay"]   = "ftp" ;
		 $list_file_loc["$value epg_recplay"]    = $epg_data ;
		 
		 $list_file_entry["$value epg_timers"]  = "$value EPG timer list";
		 $list_file_name["$value epg_timers"]   = $epg_timers;
		 $list_file_server["$value epg_timers"] = $value ;
		 $list_file_type["$value epg_timers"]   = "ftp" ;
		 $list_file_loc["$value epg_timers"]    = $epg_data ;
		 
		 $list_file_entry["$value 99999999"]  = "$value 99999999.tgd";
		 $list_file_name["$value 99999999"]   = $set_timers_tgd;
		 $list_file_server["$value 99999999"] = $value ;
		 $list_file_type["$value 99999999"]   = "ftp" ;
		 $list_file_loc["$value 99999999"]    = $epg_data ;
		 
		 $list_file_entry["$value epg_upload"]  = "$value EPG upload log";
		 $list_file_name["$value epg_upload"]   = $epg_loader_log;
		 $list_file_server["$value epg_upload"] = $value ;
		 $list_file_type["$value epg_upload"]   = "ftp" ;
		 $list_file_loc["$value epg_upload"]    = $epg_data ;
		}
		 
    if($use_teds) {
		 $list_file_entry["ted_log"]  = "TED log";
		 $list_file_name["ted_log"]   = $teds_log;
		 $list_file_server["ted_log"] = $teds_server ;
		 $list_file_type["ted_log"]   = $teds_servertype ;
		 $list_file_loc["ted_log"]    = $teds_location ;
		 
		 $list_file_entry["ted_timers"]  = "TED timers log";
		 $list_file_name["ted_timers"]   = $teds_timers;
		 $list_file_server["ted_timers"] = $teds_server ;
		 $list_file_type["ted_timers"]   = $teds_servertype ;
		 $list_file_loc["ted_timers"]    = $teds_location ;
		}
		
		foreach ($Grabbers as $index => $value) 
		{ 
		 if ($value=="") { continue ; }	
		 add_diag("[CONFIG] Grabber[$index]=$value") ;
		 $list_file_entry[$value]  = "$value log";
		 $list_file_name[$value]   = get_ini_string("Grabber $value","Log","$value.log") ;
		 $x_folder                 = get_ini_string("Grabber $value","Folder","") ;
		 $list_file_server[$value] = get_ini_string("Grabber $value","Server","Local") ;
		 if (strtoupper($list_file_server[$value])=="FTP") { $list_file_server["$value"]= $FTPservers[0] ; }
		 if ($list_file_server[$value]=="Local") { $list_file_type[$value] = "local" ; }
		 else                                    { $list_file_type[$value] = "ftp" ; }
		 if (get_ini_boolean("Grabber $value","TEDS",$use_teds)) 
		 {
		  if ($x_folder=="") { $list_file_loc[$value] = $teds_location ; }
			else { $list_file_loc[$value] = $teds_location.$separator[$teds_server].$x_folder ; }
		 }
		 else { $list_file_loc[$value] = $x_folder ; }
		 add_diag("[CONFIG] list_file_entry[$value]=".$list_file_entry[$value]) ;
		}
		 		
    if($use_trecx) {		 
		 $list_file_entry["trecx_log"]  = "TrecX log";
		 $list_file_name["trecx_log"]   = "trecx.log";
		 $list_file_server["trecx_log"] = $teds_server ;
		 $list_file_type["trecx_log"]   = $teds_servertype ;
		 $list_file_loc["trecx_log"]    = $teds_location ;
	  }
		
    if($use_pbk) {
		 $list_file_entry["timesynch"]  = "PBK Time Synch log";
		 $list_file_name["timesynch"]   = "TimeSync.log";
		 $list_file_server["timesynch"] = $FTPservers[0] ;
		 $list_file_type["timesynch"]   = "ftp" ;
		 $list_file_loc["timesynch"]    = $program_files."/Auto Start" ;
		}
		
		foreach( $ExtraLogs as $logname)
		{		 	
		 if ($logname=="") { continue ; }	 
		 $list_file_entry[$logname]  = get_ini_string("ExtraLog $logname","Description",$logname) ;
		 $list_file_server[$logname] = get_ini_string("ExtraLog $logname","Server","Local") ;
		 $list_file_loc[$logname]    = get_ini_string("ExtraLog $logname","Folder","") ;
		 $list_file_name[$logname]   = get_ini_string("ExtraLog $logname","Filename","$logname.log") ;
		 if (strtoupper($list_file_server[$logname])=="FTP") { $list_file_server["$logname"]= $FTPservers[0] ; }
		 if ($list_file_server[$logname]=="Local") { $list_file_type[$logname] = "local" ; }
		 else                                      { $list_file_type[$logname] = "ftp" ; }
		 add_diag("[CONFIG] ExtraLog $logname: ".$list_file_type[$logname]."=>".$list_file_loc[$logname].$separator[$list_file_type[$logname]].$list_file_name[$logname]) ;
		}
		 
		 //
		 // EPG section
		 //
		 $cache_epg_enabled = get_ini_boolean("EPG","EnableEPGCaching",get_ini_boolean("Web Server","EnableEPGCaching",false)) ;
		 $cache_epg_today     = get_ini_string("EPG","CacheExpiryToday",60) ;  // maximum cache period
		 $cache_epg_tomorrow     = get_ini_string("EPG","CacheExpiryTomorrow",7200) ;  // maximum cache period
		 $cache_epg_beyond     = get_ini_string("EPG","CacheExpiryBeyond",10800) ;  // maximum cache period
		 $time_zone  = get_ini_string("EPG","TimeZone",date("O")) ;
		 // EPG display values
		 $days_displayed   = min(max(get_ini_string("EPG","DaysDisplayed",7),7),14) ; // Number of days displayed in the EPG
		 $show_vcr_timers  = get_ini_boolean("EPG","ShowVCRtimers",true) ;  // Add EPG button to LINKS bar
		 $screen_width     = get_ini_string("EPG","ScreenWidth",1024) ;  // target screen width (in pixels)
		 $hour_height      = max( get_ini_string("EPG","HourHeight",150),(10*$days_displayed+20),100) ; // height of one hour of display (in pixels)
		 $minimum_duration = get_ini_string("EPG","MinimumDuration",0) ;  // Any programme with a shorter duration will NOT be displayed in the EPG
		 $hide_description = !get_ini_boolean("EPG","ShowDescription",true) ; // true/false If TRUE do NOT show the extended description in the main display
		 
		 // The following parameters determine the characteristics of any epg mouseover display
		 $mouseover_display       = get_ini_string("EPG","PopoverMaximumDisplay",9999) ; // The longest duration (minutes) to trigger a display, zero means never display.
		 $mouseover_compare_inner = get_ini_boolean("EPG","PopoverCompareInner",true) ; // if true only show popover if you cannot already see all of the text.
		 $mouseover_desc          = get_ini_boolean("EPG","PopoverDescription",!$hide_description) ; // true/false Show the extended description in the display?  TRUE will show the description
		 
		 // Set the type of EPG source to be used
		 // "xml" means any compatible XML source file
		 // "ice" means using the EPG_CACHE files that IceTV loads to the Toppy.
		 $epg_type = strtolower(get_ini_string("EPG","EPGsource","XML")) ;
		 
		 // if using an XML file set its location here		 
		 $xml_servername = get_ini_string("EPG XML","Servername","Local") ;
		 $xml_teds       = get_ini_boolean("EPG XML","TEDS",true) ;
		 $xml_folder     = get_ini_string("EPG XML","Folder","") ;
		 $xml_filename   = get_ini_string("EPG XML","Filename","not-defined") ;
		 // Folder name should start with the separator
		 //if ( substr($xml_folder,0,1)<>$separator[$xml_servername] ) { $xml_folder = $separator[$xml_servername].$xml_folder ; }
		 if ($xml_teds) 
		 {
		  if ($xml_folder=="") { $xml_folder = $teds_location ; }
			else                 { $xml_folder = $teds_location.$separator[$teds_server].$xml_folder ; }
		 }
		 $epg_xmlSource  = $xml_folder.$separator[$xml_servername].$xml_filename ; // the EPG xml source file
		 add_diag("XML $xml_servername | $xml_teds | $xml_folder | $xml_filename") ;
		 
		 
		 // If using ICE files the location is set here		 
		 $ice_servername     = get_ini_string("EPG ICE","Servername",$MyToppies[0]) ;
		 $ice_folder         = get_ini_string("EPG ICE","Folder",$TFicetv[$ice_servername]) ;
		 //$ice_tz_offset      = get_ini_string("EPG ICE","TimezoneOffset",date("Z")/60) ;
		 $ice_tz_offset      = get_ini_string("EPG ICE","TimezoneOffset",local_offset(time())) ;
		 $ice_identifier     = get_ini_string("EPG ICE","Identifier","*EPG_CACHE") ;
		 // Folder name should start with the separator
		 if ( substr($ice_folder,0,1)<>$separator[$ice_servername] ) { $ice_folder = $separator[$ice_servername].$ice_folder ; }
		 $ice_offset_seconds = 60*$ice_tz_offset ;
		 add_diag("ICE $ice_servername | $ice_identifier | $ice_folder | $ice_tz_offset") ;
		 $epg_ice_loc = $ice_folder ; 
		 
		 
		 // If using TGD files the location is set here
		 $epg_tgd_loc = "/ICE" ; // the ICE EPG source file
		 
		 $tgd_servername    = get_ini_string("EPG TGD","Servername",$MyToppies[0]) ;
		 $tgd_folder        = get_ini_string("EPG TGD","Folder",$TFepgdata[$tgd_servername]) ;
		 $tgd_identifier    = get_ini_string("EPG TGD","Identifier","*.tgd") ;
		 $epg_tgd_yesterday = get_ini_boolean("EPG TGD","UseYesterday") ;
		 $epg_tgd_start     = get_ini_boolean("EPG TGD","UseToday") ;
		 $epg_tgd_end       = get_ini_boolean("EPG TGD","UseTomorrow") ;
		 $epg_tgd_useLCN    = get_ini_boolean("EPG TGD","UseLCN",get_ini_boolean("Topfield $tgd_servername","UseLCN",$use_LCN)) ;
		 // Folder name should start with the separator
		 if ( substr($tgd_folder,0,1)<>$separator[$tgd_servername] ) { $tgd_folder = $separator[$tgd_servername].$tgd_folder ; }
		 $epg_tgd_loc = $tgd_folder ; 
		 
		 // For mei files                  
 		 $mei_servername    = get_ini_string("EPG MEI","Servername",$MyToppies[0]) ;
 		 $mei_folder        = get_ini_string("EPG MEI","Folder",$TFepgdata[$mei_servername]) ;
 		 $epg_mei_identifier= get_ini_string("EPG MEI","Identifier","Freeview.mei") ;
 		 $epg_mei_cachetime= get_ini_string("EPG MEI","FileCacheTime","60") ;
 		 // Folder name should start with the separator
 		 //if ( substr($mei_folder,0,1)<>$separator[$mei_servername] ) { $mei_folder = $separator[$mei_servername].$mei_folder ; }
 		 $epg_mei_loc = $mei_folder ; 
 		 $epg_mei_epgupload = $TFprogramfiles[$mei_servername] . "/epg_upload.ini";


		 
		 
		// finished reading configuration
		// check if the working folder exists
		if ($wf=@opendir($local_files)) { closedir($wf) ; }
		elseif (mkdir($local_files,0777)) {}
		else { echo "Working folder $local_files does not exist<br>\n" ; }
		
	// Now do the security check	
		
		check_security() ;
		 	 
		 // "form_js makes default values available to javascript
		 // Do not alter anything below here
?>
<?php 
function yes_if_true($flag)
{
 if     ($flag===true)  { return "Yes" ; }
 elseif ($flag===false) { return "No" ; }
 elseif ($flag=="1")    { return "Yes" ; }
 elseif ($flag<>"")     { return $flag ; }
 else                   { return "No" ; }
}

function force_boolean($value)
{
 if ($value) { return true ; }
 else        { return false ; }
}

function set_boolean($value, $default=false )
{
 if (is_bool($value)) { return $value ; }
 switch ( strtolower($value) )
 {
  case 1        :
  case "yes"    :
	case "true"   :
	 return true  ;
	 break ;
	case "no"     :
	case "false"  :
	 return false ;
	 break ;	 
 } 
 return $default ;
}

function local_offset($timestring) {
 return zone_offset($GLOBALS["time_zone"]) ;
}

function zone_offset($zone_string) {
 return ( (substr($zone_string,0,1)."1")*( (substr($zone_string,1,2)*60)+substr($zone_string,3,2) ) ) ; ;
}

function zone_string($off) {
 $x = ($off<0?"-":"+").sprintf("%02d%02d",abs($off)/60,abs($off)%60) ;
 //add_diag("[CONFIG] zone $x") ; 
 return $x ;
}

function server_in_use($servername)
{
 // Is this server in use by a background process (eg transfer)?
 // and of a type that does not permit multiple access (ftpd-topfield pre v0.6.9)
 return false ;  //always returns FALSE for the moment
}

?>
