<?php
echo "<!-- TGD processing included -->\n";
include_once ("security_check.php");
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

* Redistributions must retain the above copyright
notice, this list of conditions and the following disclaimer.

* The name of John Stevens may not
be used to endorse or promote products derived from this
software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php
//include_once("security_check.php") ;

echo "<!-- TGD processing included -->\n";
$channel_id = array();
$epgPID = 0;
$tgdcachefiles = array();
$tgdfilecount = 0;

$yesterday = date("YmdHi", strtotime(substr($start_time, 4, 2) . "/" . substr($start_time,
    6, 2) . "/" . substr($start_time, 0, 4) . " " . substr($start_time, 8, 2) . ":" .
    substr($start_time, 10, 2)) - 24 * 60 * 60);

add_diag("TGD search yesterday=$yesterday");
add_diag("TGD search     today=$start_time");
add_diag("TGD search  tomorrow=$yesterday");
add_diag("TGD server=" . $FTPaddress[$tgd_servername] . ":" . $FTPport[$tgd_servername]);

if ($ftp = ftp_connect($FTPaddress[$tgd_servername], $FTPport[$tgd_servername])) {
    ftp_login($ftp, $FTPuser[$tgd_servername], $FTPpw[$tgd_servername]);
    ftp_chdir($ftp, $epg_tgd_loc);
    add_diag("TGD ftpuser " . $FTPuser[$tgd_servername]);
    add_diag("TGD ftpfolder " . $epg_tgd_loc);
    $files = ftp_nlist($ftp, "*.tgd");
    //print_r($files) ;
    foreach ($files as $filename) {
        add_diag("TGD found $filename");
        echo "<!-- TGD found: $filename => checking type -->\n";
        if (substr_count(strtolower($filename), ".tgd") > 0) {
            echo "<!-- TGD found: $filename => checking date -->\n";
            if ((!$epg_tgd_start or substr($filename, 0, 8) <> substr($start_time, 0, 8)) and
                (!$epg_tgd_end or substr($filename, 0, 8) <> substr($end_time, 0, 8)) and (!$epg_tgd_yesterday or
                substr($filename, 0, 8) <> substr($yesterday, 0, 8))) {
                continue;
            }
            $tgdfilecount++;
            echo "<!-- TGD found: $filename => get -->\n";
            ftp_get($ftp, $local_files . DIRECTORY_SEPARATOR . "EPG_CACHE_$tgdfilecount", $epg_tgd_loc .
                "/" . $filename, FTP_ASCII);
            //read_epg_cache($local_files.DIRECTORY_SEPARATOR."EPG_CACHE") ;
            $tgdcachefiles[$tgdfilecount] = $local_files . DIRECTORY_SEPARATOR . "EPG_CACHE_$tgdfilecount";
            echo "<!-- TGD found: $filename => EPG_CACHE_$tgdfilecount -->\n";
        } else {
        	//
        }
    }
    echo "<!-- TGD found: finished list -->\n";
    //unlink($local_files.DIRECTORY_SEPARATOR."EPG_CACHE") ;
    ftp_quit($ftp);
} else {
    echo "<!-- TGD cannot connect to $ftp_server -->\n";
}

function read_epg_cache($files)
{
    global $channels, $channel_id, $chn_hide, $epgPID, $ice_offset_seconds, $start_time,
        $end_time;
    global $epg_tgd_useLCN, $tgd_servername, $lcn_chn_trans;

    echo "<!-- TGD read files started -->\n";
    $programmes = array();

    $found_data = false;
    foreach ($files as $filename) {
        echo "<!-- TGD read file $filename -->\n";
        if (!($rows = file($filename))) {
            continue;
        }
        echo "<!-- TGD process file $filename (" . count($rows) . " rows) -->\n";
        add_diag("TGD finished reading $filename(" . count($rows) . " entries)");
        $found_data = true;
        foreach ($rows as $row) {
        	//echo "." ;
            list($channel, $start, $duration, $title, $subtitle, $desc) = explode("\t", $row);
            //add_diag("TGD $start,$channel,$duration,$title,$subtitle,$category") ;
            //echo "<!-- TGD entry channel $channel -->\n" ;
            //echo "<!-- TGD entry useLCN=".$epg_tgd_useLCN[$tgd_servername]." -->\n" ;
            //print_r($lcn_chn_trans) ;
            //echo "<!-- TGD entry channel $channel=".$lcn_chn_trans[$channel]." -->\n" ;
            if ($epg_tgd_useLCN[$tgd_servername]) {
                $channel = $lcn_chn_trans[$channel];
            }
            $temp = array();
            $epgPID += 1;
            $temp["epgPID"] = $epgPID;
            $temp["epgTitle"] = $title;
            $temp["epgSubTitle"] = $subtitle;
            $temp["epgChannel"] = $channel;
            $temp["epgDuration"] = $duration;
            $temp["epgDescription"] = $desc;
            //$start_timestamp = strtotime(substr($start,4,2)."/".substr($start,6,2)."/".substr($start,0,4)." ".substr($start,8,2).":".substr($start,10,2)) ;
            $start_timestamp = strtotime(str_replace("-", "/", $start));
            $stop_timestamp = $start_timestamp + ($duration * 60);
            $temp["epgStart"] = date("YmdHi", $start_timestamp);
            $temp["epgStop"] = date("YmdHi", $stop_timestamp);
            $temp["epgRepeat"] = false;

            //add_diag("TGD read $title from ".$temp["epgStart"]." to ".$temp["epgStop"]." * ".substr($start,4,2)."/".substr($start,6,2)."/".substr($start,0,4)." ".substr($start,8,2).":".substr($start,10,2) ) ;
            //add_diag("TGD read $title from ".$temp["epgStart"]." to ".$temp["epgStop"]." * ".str_replace("-","/",$start) ) ;

            $s1 = $start_time;
            $s2 = substr($temp["epgStart"], 0, 12);
            $e1 = $end_time;
            $e2 = substr($temp["epgStop"], 0, 12);

            $ss = (strcmp($s1, $s2) < 0) && (strcmp($s2, $e1) < 0);
            $ee = (strcmp($s1, $e2) < 0) && (strcmp($e2, $e1) < 0);

            //echo "s=$s2=$ss e=$e2=$ee or=".($ss or $ee)."<br>\n" ;
            if (!array_key_exists($temp["epgChannel"], $chn_hide)) {
                $chn_hide[$temp["epgChannel"]] = true;
            }
            if (($ss or $ee) and !$chn_hide[$temp["epgChannel"]] and ($temp["epgDuration"] >=
                $GLOBALS["minimum_duration"])) {
                //echo "ok s=$s2=$ss e=$e2=$ee or=".($ss or $ee)." $s2 $e2<br>\n" ;
                $programmes[$temp["epgPID"]] = $temp;
                $channels[$temp['epgChannel']] = true;
                //echo $temp["epgChannel"]."=".$title."<br>\n" ;
            }
        }
        echo "\n" ;
        echo "<!-- TGD process file $filename completed -->\n";
        if ($found_data) {
            return $programmes;
        }
        return false;
    }
}

function parsefile()
{
    global $tgdcachefiles;

    echo "<!-- TGD parsing files started -->\n";
    $result = read_epg_cache($tgdcachefiles);
    echo "<!-- TGD parsing files ended -->\n";
    return $result;
}


?>